---

- name: Install required system dependencies
  ansible.builtin.apt:
    name: "{{ item }}"
    update_cache: true
  loop: "{{ docker_dependencies }}"

- name: Add docker GPG apt key
  ansible.builtin.apt_key:
    url: "{{ docker_gpg_url }}"
    keyring: "{{ docker_gpg_keyring }}"
    id: "{{ docker_gpg_fingerprint }}"
    state: present

- name: Add docker repository
  ansible.builtin.apt_repository:
    repo: "{{ docker_repo }}"
    state: present

- name: "Install docker-{{ docker_edition }}"
  ansible.builtin.apt:
    name: "{{ item }}"
    state: "{{ docker_packages_state }}"
    update_cache: true
  loop: "{{ docker_packages }}"

- name: Instal docker-compose plugin pip-version
  when: docker_compose_pip_version
  block:
    - name: Install pip
      ansible.builtin.apt:
        name:
          - python3-pip
        state: present

    - name: Install docker-compose pip-version
      ansible.builtin.pip:
        name: "{{ item }}"
        state: "{{ docker_packages_state }}"
      loop:
        - docker
        - docker-compose

- name: Ensure docker users are added to the docker group
  ansible.builtin.user:
    name: "{{ item }}"
    groups: docker
    append: true
  with_items: "{{ docker_users }}"
  when: docker_packages_state == "present"
